#include "test.cnf"

#if (FSINMEM_SIZE!=0)
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "mm\mproc.h"
#include "mm\tuoxhead.h"
#include "kernel\proc_pub.h"
#include "kernel\proc.h"
#include "test\dossvc.h"
#include "lib\include\string.h"

void addModuleToProc(int procPos, Word csegment, void (*mainOffset)(void),
		     Word sdsegment, Word highestSP,
		     Word dataLen,
		     int* paramsForMain, int numParams,
		     int queueToAdd);


int loadFS(char* fileName, Word segment)
{
 int handle,err;
 unsigned long buf[TUOX_HEADER_LEN/4];

 if ((handle=openFileDOS(fileName))<0) return handle;
 if (readFileDOS(handle,(char*) buf,TUOX_HEADER_LEN,&err)
   !=TUOX_HEADER_LEN) { closeFileDOS(handle); return err; }

 if (readFileDOSex(handle,0,segment,FSINMEM_SIZE*16,&err)==-1)
   { closeFileDOS(handle); return err; }

/*
 mproc[FS].mp_seg[T].mem_vir=proc[FS].p_map[T].mem_vir=0;
 mproc[FS].mp_seg[T].mem_phys=proc[FS].p_map[T].mem_phys=segment;
 mproc[FS].mp_seg[T].mem_len=proc[FS].p_map[T].mem_len=buf[TH_TextLen/4]/16;

 mproc[FS].mp_seg[D].mem_vir=proc[FS].p_map[D].mem_vir=0;
 mproc[FS].mp_seg[D].mem_phys=proc[FS].p_map[D].mem_phys=segment+(buf[TH_TextLen/4]/16);
 mproc[FS].mp_seg[D].mem_len=proc[FS].p_map[D].mem_len=buf[TH_DataLen/4]/16;

 mproc[FS].mp_seg[S].mem_vir=proc[FS].p_map[S].mem_vir
  = buf[TH_DataLen/4]+buf[TH_BssLen/4];
 mproc[FS].mp_seg[S].mem_phys=proc[FS].p_map[S].mem_phys=
   mproc[FS].mp_seg[D].mem_phys;
 mproc[FS].mp_seg[S].mem_len=proc[FS].p_map[S].mem_len=
   (buf[TH_Total/4]-(buf[TH_BssLen/4]+buf[TH_DataLen/4]+buf[TH_TextLen/4]))/16;
*/

 closeFileDOS(handle);

 addModuleToProc(FS,segment,0,
 segment+(buf[TH_TextLen/4]/16),
 (buf[TH_Total/4]-buf[TH_TextLen/4]),
 buf[TH_DataLen/4],
 NULL,0,
 SERVER_Q);

 memcpy(&(mproc[FS].mp_seg),&(proc[FS].p_map),sizeof(struct mem_map)*NR_SEGS);
  /* !!! pozdeji nejak predat samostatnemu MM */

 return 0;
}

#define MK_FP( seg,ofs )( (void _seg * )( seg ) +( void near * )( ofs ))

void addModuleToProc(int procPos, Word csegment, void (*mainOffset)(void),
		     Word sdsegment, Word highestSP,
		     Word dataLen,
		     int* paramsForMain, int numParams,
		     int queueToAdd) {
/*
   Pridani modulu serveru do proc[] a do zadane fronty planovace (na konec).
   Je-li queueToAdd==-1, neprida se do zadne fronty
*/
 Word far* spptr=MK_FP(sdsegment,highestSP-1);
 int i;
 struct proc* procAddr=proc_addr(procPos);

 if (paramsForMain) {
 /* POZOR: do procesu se vstupuje IRETem, takze na zasobniku musi byt
	   PSW,CS,IP a parametry nesmi nasledovat, jak by se cekalo,
	   ale musi byt jeste NAD PSW: po IRETu tam zbydou a skoci se do
	   rutiny, ktera tyto parametry ocekava; ze tam uz neni zadna dalsi
	   navratova adresa nevadi, protoze hlavni rutina procesu nekonci
	   RETem.
	   Dalsi finta je v tom, ze parametr neni bezprostredne nad PSW,
	   protoze prekladac ocekava, ze pred parametrem bude jeste navratova
	   adresa (NEAR). */

   for (i=0; i<numParams; i++)
    *spptr--=*paramsForMain++;

   /* jedna pozice navic jako ze za navratovou adresu */
   if (numParams) spptr--;
  }

  /* nachystame stack pro prvni IRET (provadeny pri naplanovani) */
  *spptr--=INIT_PSW;
  *spptr--=csegment;
  *spptr=(int) mainOffset;

  proc[procPos].p_sp=(int) spptr;
  proc[procPos].p_splimit=(int*) dataLen;

  proc[procPos].p_reg[AX_REG]=proc[procPos].p_reg[BX_REG]=
  proc[procPos].p_reg[CX_REG]=proc[procPos].p_reg[DX_REG]=
  proc[procPos].p_reg[SI_REG]=proc[procPos].p_reg[DI_REG]=
  proc[procPos].p_reg[BP_REG]=0;

  proc[procPos].p_reg[DS_REG]=proc[procPos].p_reg[ES_REG]=
  proc[procPos].p_reg[SS_REG]=sdsegment;

  proc[procPos].p_pcpsw.pc=(int) mainOffset;
  proc[procPos].p_pcpsw.cs=csegment;
  proc[procPos].p_pcpsw.psw=INIT_PSW;

  proc[procPos].p_flags=0;
  proc[procPos].p_pid=NO_PID;

  proc[procPos].p_map[T].mem_phys = csegment;
  proc[procPos].p_map[D].mem_phys = sdsegment;
  proc[procPos].p_map[S].mem_phys = sdsegment;

  proc[procPos].p_map[T].mem_len = VERY_BIG; /* snad nepodstatne */
  proc[procPos].p_map[D].mem_len = (dataLen / 16) + 1;
  proc[procPos].p_map[S].mem_len = (highestSP / 16) + 1;

  proc[procPos].p_map[T].mem_vir = 0;
  proc[procPos].p_map[D].mem_vir = 0;
  proc[procPos].p_map[S].mem_vir = dataLen;
   /* v modulech FS a MM nepotrebujeme gap */

 proc[procPos].user_time=proc[procPos].sys_time=
  proc[procPos].child_utime=proc[procPos].child_stime=0;
 proc[procPos].p_alarm=0;
 proc[procPos].p_callerq=proc[procPos].p_sendlink=
  proc[procPos].p_nextready=NULL;
  proc[procPos].p_messbuf=NULL;
 proc[procPos].p_pending=0;
 proc[procPos].p_getfrom=-1;

 if (queueToAdd>=0) {
  /* pridej na konec fronty */
  if (rdy_head[queueToAdd]==NULL)
   rdy_head[queueToAdd]=rdy_tail[queueToAdd]=procAddr;
   else {
    (rdy_tail[queueToAdd])->p_nextready=procAddr;
    rdy_tail[queueToAdd]=procAddr;
   }
 }

}



#endif