// TEST_PHASE 17
/* Test FS, ten docasne slinkovan s kernelem */
/* FILE CREATION, COPYING AND VERIFICATION TEST */
/* (creat,open,close,seek,read,write) */
// Written by P.G.

#include "kernel\makra.h"
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "COMMON\com.h"
#include "COMMON\callnr.h"
#include "COMMON\stat.h"

#include "test\kprintf.h"

#include "FS\COMMON\fsconst.h"
#include "FS\COMMON\fsmes.h"

#define PROC1 (NR_TASKS+NR_SERVS)


#define MK_FP( seg,ofs )( (void _seg * )( seg ) +( void near * )( ofs ))

static message m;

void proc1(void) {

#define SRC_FILE "/file.1st"
#define DST_FILE "/file.203"

 int fd, wfd;
 int i,result=1;
 static char buf[2];

 kprintf(0,0,2,"FS TEST: file copy test");

 m.m_type = C_CREAT;
 m.fs_name = DST_FILE;
 m.fs_mode = I_REGULAR | 0777;

 send_recv(FS,m);
 wfd=m.fs_fd;
 kprintf(1,0,7,"Destination file handle: %u",wfd);

 m.m_type = C_OPEN;
 m.fs_name = SRC_FILE;
 m.fs_mode = S_IREAD;

 send_recv(FS,m);
 fd=m.fs_fd;
 kprintf(2,0,7,"Source file handle: %u",fd);

 if (fd>=0 && wfd>=0) {
  do {

   m.m_type = C_READ;
   m.fs_fd = fd;
   m.fs_buffer=buf;
   m.fs_nbytes=1;
   m.fs_seg=D;
   send_recv(FS,m);
   result=m.fs_errcode;
   if (result<0) {
	   kprintf(3,0,5,"Read error: %u",result);
	   break;
   } else kprintf(3,0,7,"%c",buf[0]);

   if (result==1) {
     m.m_type = C_WRITE;
     m.fs_fd = wfd;
     m.fs_buffer=buf;
     m.fs_nbytes=1;
     m.fs_seg=D;
     send_recv(FS,m);
     result=m.fs_errcode;
     if (result<0) {
	     kprintf(3,0,5,"Write error: %u",result);
	     break;
     }
   }
  } while (result==1);

  m.m_type = C_CLOSE;
  m.fs_fd = wfd;
  send_recv(FS,m);
  kprintf(4,0,7,"Destination close result: %u",m.fs_errcode);


  m.m_type = C_OPEN;
  m.fs_name = DST_FILE;
  m.fs_mode = S_IREAD;
  send_recv(FS,m);
  wfd=m.fs_fd;
  kprintf(5,0,7,"Destination file re-opened for reading - handle: %u",wfd);

  m.m_type = C_LSEEK;
  m.fs_fd1=fd;
  m.fs_offset1=0;
  m.fs_whence=0; /* from the begginning of the file */
  send_recv(FS,m);
  kprintf(6,0,7,"Source file seek(0) result: %l",m.fs_pos1);

  /* porovnej obsahy souboru */

  if (fd>=0 && wfd>=0) {
  int i=1;
   do {

    m.m_type = C_READ;
    m.fs_fd = fd;
    m.fs_buffer=buf;
    m.fs_nbytes=1;
    m.fs_seg=D;
    send_recv(FS,m);
    result=m.fs_errcode;
    if (result<0) {
	    kprintf(7,0,5,"Compare read error (fd): %u",result);
	    break;
    } else kprintf(7,0,7,"%c",buf[0]);

    m.m_type = C_READ;
    m.fs_fd = wfd;
    m.fs_buffer=buf+1;
    m.fs_nbytes=1;
    m.fs_seg=D;
    send_recv(FS,m);
    result=m.fs_errcode;
    if (result<0) {
	      kprintf(7,0,5,"Compare read error (wfd): %u",result);
	      break;
    }
    if (buf[0]!=buf[1]) i=0;
   } while (result==1);
  if (i==1) kprintf(7,0,7,"FILE COPY COMPLETE - VERIFICATION SUCCESSFUL");
   else kprintf(7,0,7,"FILE COPY VERIFICATION FAILURE");
  }

  m.m_type = C_CLOSE;
  m.fs_fd = fd;
  send_recv(FS,m);
  kprintf(8,0,7,"Source close result: %u",m.fs_errcode);

  m.m_type = C_CLOSE;
  m.fs_fd = wfd;
  send_recv(FS,m);
  kprintf(9,0,7,"Destination close result: %u",m.fs_errcode);
 }
  else kprintf(3,0,7,"Exiting test");

 m.m_type = C_SYNC;
 send_recv(FS,m);

 /* end with endless loop (the process must not exit, otherwise
    IP (PC) would get to some random place */

 while(1);
}

