// TEST_PHASE 22
/* Test FS, ten docasne slinkovan s kernelem */
/* test chroot(): ocekava na svazku strukturu z test21: /a/b/c */
// Written by P.G.

#include "kernel\makra.h"
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "COMMON\com.h"
#include "COMMON\callnr.h"
#include "COMMON\stat.h"

#include "test\kprintf.h"

#include "FS\COMMON\fsconst.h"
#include "FS\COMMON\fsmes.h"
#include "FS\CACHE\buf.h"

#include "lib\include\string.h"

#define PROC1 (NR_TASKS+NR_SERVS)


#define MK_FP( seg,ofs )( (void _seg * )( seg ) +( void near * )( ofs ))

static message m;

int dir(char* dirName, int line1) {
 /* prints the contents of the root dir */
 /* returns the number of directory entries */

 int fd;
 static struct dir_struct item;
 int entries=0;

 m.m_type = C_OPEN;
 m.fs_name = dirName;
 m.fs_mode = S_IREAD;

 send_recv(FS,m);
 fd=m.fs_fd;
 if (fd<0) return fd;

 do {
   m.m_type = C_READ;
   m.fs_fd = fd;
   m.fs_buffer=(char*) (&item);
   m.fs_nbytes=sizeof (struct dir_struct);
   m.fs_seg=D;
   send_recv(FS,m);

   if (m.fs_errcode<0) return m.fs_errcode;
   if (m.fs_errcode==sizeof (struct dir_struct)) {
    if (item.d_inum!=0 && strcmp(item.d_name,".") && strcmp(item.d_name,".."))
     kprintf(line1+entries++,0,7,"%u : %s",item.d_inum,item.d_name);
   }
 } while (m.fs_errcode==sizeof (struct dir_struct));
 return entries;
}

void proc1(void) {

 int fd,line=1,i;

 m.m_type = C_CHROOT;
 m.fs_name = "/a/b";
 send_recv(FS,m);
 kprintf(line++,0,7,"chroot(\"/a/b\") error code: %i",m.fs_errcode);

 kprintf(line++,0,7,"Directory of (new) /:");
 i=dir("/",line);
 if (i>=0) line+=i; else kprintf(line++,0,7,"Directory read error: %i",i);

 m.m_type = C_CREAT;
 m.fs_name = "/c/x.x";
 m.fs_mode = I_REGULAR | 0777;
 send_recv(FS,m);
 fd=m.fs_fd;
 if (fd<0) kprintf(line++,0,7,"File /c/x.x creation error: %i",fd);
    else {
      kprintf(line++,0,7,"File /c/x.x created");
      m.m_type = C_CLOSE;
      m.fs_fd = fd;
      send_recv(FS,m);
      if (m.fs_errcode!=0)
       kprintf(line++,0,7,"File /c/x.x close after creation error: %i",m.fs_errcode);
    }

 kprintf(line++,0,7,"Directory of (new) /c:");
 i=dir("/c",line);
 if (i>=0) line+=i; else kprintf(line++,0,7,"Directory read error: %i",i);

 m.m_type = C_CHROOT;
 m.fs_name = "/c";
 send_recv(FS,m);
 kprintf(line++,0,7,"chroot(\"/c\") error code: %i",m.fs_errcode);

 kprintf(line++,0,7,"Directory of (new) /:");
 i=dir("/",line);
 if (i>=0) line+=i; else kprintf(line++,0,7,"Directory read error: %i",i);

 m.m_type = C_SYNC;
 send_recv(FS,m);

 /* end with endless loop (the process must not exit, otherwise
    IP (PC) would get to some random place */

 while(1);
}

