// TEST_PHASE 23
/* Test FS, ten docasne slinkovan s kernelem */
/* test stat, fstat, chmod, chown, utime */
// Written by P.G.

#include "kernel\makra.h"
#include "COMMON\type.h"
#include "COMMON\const.h"
#include "COMMON\com.h"
#include "COMMON\callnr.h"
#include "COMMON\stat.h"

#include "test\kprintf.h"

#include "FS\COMMON\fsconst.h"
#include "FS\COMMON\fsmes.h"
#include "FS\CACHE\buf.h"

#include "lib\include\string.h"

#define PROC1 (NR_TASKS+NR_SERVS)


#define MK_FP( seg,ofs )( (void _seg * )( seg ) +( void near * )( ofs ))

static message m;

int print_stat(struct stat s, int line1) {
 kprintf(line1++,0,7,"device: %u, i_num: %u, mode: %u, links: %u, uid: %u, gid: %u ",
  s.st_dev,s.st_ino,s.st_mode,(unsigned int) s.st_nlink,s.st_uid,(unsigned int) s.st_gid);
 kprintf(line1++,0,7,"size: %l, time: %l",s.st_size,s.st_atime);
 return 2;
}

#define TEST_FILE "test.tst"
int line=1;

void stat(void) {
 static struct stat s;

 m.m_type = C_STAT;
 m.fs_name = TEST_FILE;
 m.fs_buff=(char*) &s;
 send_recv(FS,m);
 kprintf(line++,0,7,"stat() error code: %i",m.fs_errcode);
 line+=print_stat(s,line);
}

void proc1(void) {

 int fd;

 m.m_type = C_CREAT;
 m.fs_name = TEST_FILE;
 m.fs_mode = I_REGULAR | 0777;
 send_recv(FS,m);
 fd=m.fs_fd;
 if (fd<0) kprintf(line++,0,7,"Test file creation error: %i",fd);
    else {
      kprintf(line++,0,7,"Test file created");
      m.m_type = C_CLOSE;
      m.fs_fd = fd;
      send_recv(FS,m);
      if (m.fs_errcode!=0)
       kprintf(line++,0,7,"Test file close after creation error: %i",m.fs_errcode);
    }

 stat();

 m.m_type = C_CHMOD;
 m.fs_name = TEST_FILE;
 m.fs_mode = 0123;
 send_recv(FS,m);
 kprintf(line++,0,7,"chmod (0123) error code: %i",m.fs_errcode);

 m.m_type = C_CHOWN;
 m.fs_name = TEST_FILE;
 m.fs_owner= 1;
 m.fs_group= 10;
 send_recv(FS,m);
 kprintf(line++,0,7,"chown (o=1,g=10) error code: %i",m.fs_errcode);

 stat();

 m.m_type = C_UTIME;
 m.fs_namet = TEST_FILE;
 m.fs_time_s= 12345L;
 send_recv(FS,m);
 kprintf(line++,0,7,"utime(12345L) error code: %i",m.fs_errcode);

 stat();

 m.m_type = C_SYNC;
 send_recv(FS,m);

 /* end with endless loop (the process must not exit, otherwise
    IP (PC) would get to some random place */

 while(1);
}

